/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package uk.co.tp53.NEATG_A;

/***
 *
 * @author Pan.Pantziarka
 * 
 */
public abstract class AbstractTreatmentStrategy implements IStrategy {
    
    @Override
    public abstract double[] agePopulation(GridElement gE, int nutrientSupply,
            double[] gFactors);
    
    @Override
    public abstract boolean trigger(int gen, double invasion);

    @Override
    public abstract int getGen();

    @Override
    public abstract void setGen(int gen);

    @Override
    public abstract double getInvasion();

    @Override
    public abstract void setInvasion(double invasion);

    @Override
    public abstract boolean isActive();

    @Override
    public abstract void setSchedule(NeatScenario schedule);
    
    protected abstract void prepareNutrientAndFactors(int nutrientSupply, 
            GridElement gE, double[] gFactorSupply);
}
