/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package uk.co.tp53.NEATG_A;

/**
 *
 * @author panik
 */
public class StrategyNoTreatment extends TreatmentStrategy {

    @Override
    public double[] agePopulation(GridElement gE, int nutrientSupply,
            double[] gFactorSupply) {

        prepareNutrientAndFactors(nutrientSupply, gE, gFactorSupply);

        //Age the whole population - based on food and factors
        for (NeatCell eaCell : gE.eaCells.values()) {
            if (eaCell.getState() == CellState.HEALTHY) {
                eaCell.feedCell(nutrient * eaCell.getNutrientTarget());
                eaCell.processFactors(shareOfFactors);
                eaCell.updateFitness(shareOfFactors);
            }
            eaCell.changeState(gE.gridIsNecrotic, gE.handshake(eaCell),
                gE.getHandshakeTolerance());
        }
        return shareOfFactors;
    }

    @Override
    public boolean trigger(int gen, double invasion) {
        return true;
    }

    @Override
    public void setSchedule(NeatScenario schedule) {
        //Do nothing
    }
}