/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package uk.co.tp53.NEATG_A;

public class TreatmentStrategy extends AbstractTreatmentStrategy {

    protected NeatScenario schedule;
    protected int gen;
    protected double invasion;
    protected boolean isActive;
    protected double nutrient;
    protected int[] sumOfTargets;
    protected double[] totalFactorSupply;
    protected double[] shareOfFactors;

    @Override
    public double[] agePopulation(GridElement gE, int nutrientSupply,
            double[] gFactors) {

        throw new UnsupportedOperationException("agePopulation not implemented");
    }

    @Override
    public boolean trigger(int gen, double invasion) {
        throw new UnsupportedOperationException("trigger not implemented");
    }

    @Override
    public int getGen() {
        return gen;
    }

    @Override
    public void setGen(int gen) {
        this.gen = gen;
    }

    @Override
    public double getInvasion() {
        return invasion;
    }

    @Override
    public void setInvasion(double invasion) {
        this.invasion = invasion;
    }

    @Override
    public boolean isActive() {
        return isActive;
    }

    @Override
    public void setSchedule(NeatScenario schedule) {
        throw new UnsupportedOperationException("setSchedule not implemented");
    }

    public double[] getTotalFactorSupply(double[] gFS, double[] laggedFS) {
        return NeatUtils.sumDblArray(gFS, laggedFS);
    }

    @Override
    protected void prepareNutrientAndFactors(int nutrientSupply, GridElement gE,
            double[] gFactorSupply) {
        //Prepare nutrient supply
        nutrient = (double) nutrientSupply / gE.getNutrientShare();
        //Take account of the gene factors too
        sumOfTargets = gE.getTargets();
        //lagged + current factor supply
        totalFactorSupply = getTotalFactorSupply(gFactorSupply,
                gE.laggedGeneSupply);

        shareOfFactors = new double[sumOfTargets.length];
        for (int i = 0; i < sumOfTargets.length; i++) {
            shareOfFactors[i] = totalFactorSupply[i] / sumOfTargets[i];
        }
    }
}
